﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace BindObjProperty
{
   

    public class ViewModel: INotifyPropertyChanged
    {
        private string[] names = { "Mary", "Sam", "Bill", "Charlie", "Rich", "Sue", "Sally","Mark","Jane","Tammy" };
        private string[] cities = {"Cranbury","Sofia","East Windsor","Princeton","New Brunswick",
                                      "Albany","Lake George","Saratoga","Gore","Chicago"};
        private string[] states = { "NJ", "N/A", "NJ", "NJ", "NJ", "NJ", "NY", "NY", "NY","NY","IL" };
        public ObservableCollection<Person> People { get; set; }

        public ViewModel()
        {
            People = new ObservableCollection<Person>();
            for (int i = 0; i < 5; i++)
            {
                People.Add(new Person()
                {
                    Name = names[i],
                    Addr = new Address() { City = cities[i], State = states[i] }
                });
            }
            for (int i = 5; i <10; i++)
            {
                People.Add(new Person()
                {
                    Name = names[i]
                });
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
    public class Person : INotifyPropertyChanged
    {
        private string _name;
        private Address _address;

        public string Name
        {
            get { return _name; }
            set
            {
                if (_name != value)
                {
                    _name = value;
                    OnPropertyChanged("Name");
                }
            }
        }
        public Address  Addr
        {
            get { return _address; }
            set
            {
                if (_address != value)
                {
                    _address = value;
                    OnPropertyChanged("Addr");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
    public class Address : INotifyPropertyChanged
    {
        private string _city;
        private string _state;

        public string City
        {
            get { return _city; }
            set
            {
                if (_city != value)
                {
                    _city = value;
                    OnPropertyChanged("City");
                }
            }
        }

        public string State
        {
            get { return _state; }
            set
            {
                if (_state != value)
                {
                    _state = value;
                    OnPropertyChanged("State");
                }
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
